﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading;
using System.Windows.Forms;

namespace Control.Invoke_Control.BeginInvoke
{
    public partial class Form1 : Form
    {
        private delegate void SomeWorkDelegate();
        private SomeWorkDelegate del;

        public Form1()
        {
            InitializeComponent();
            del = SomeWork;
        }

        private void SomeWork()
        {
            txt_Message.Text += "\r\n----------控件线程：" + Thread.CurrentThread.ManagedThreadId + "---开始工作\r\n";
            //代码Invoke
            Thread.Sleep(2000);
            txt_Message.Text += "\r\n----------控件线程：" + Thread.CurrentThread.ManagedThreadId + "---开始结束\r\n";
        }

        private void btn_Main_Invoke_Click(object sender, EventArgs e)
        {
            //执行顺序：代码A -> 代码Invoke -> 代码B
            //都是在主线程中执行

            txt_Message.Text = "";
            txt_Message.Text += "主线程：" + Thread.CurrentThread.ManagedThreadId + "---开始工作\r\n";
            //代码A
            this.txt_Message.Invoke(del);
            //代码B
            txt_Message.Text += "\r\n主线程：" + Thread.CurrentThread.ManagedThreadId + "---开始结束\r\n";
        }

        private void btn_Main_BeginInvoke_Click(object sender, EventArgs e)
        {
            //执行顺序：代码A -> 封装消息，并在UI线程中注册消息 -> 代码B -> 代码Invoke
            //都是在主线程中执行

            txt_Message.Text = "";
            txt_Message.Text += "主线程：" + Thread.CurrentThread.ManagedThreadId + "---开始工作\r\n";
            //代码A
            this.txt_Message.BeginInvoke(del);
            //代码B
            txt_Message.Text += "\r\n主线程：" + Thread.CurrentThread.ManagedThreadId + "---开始结束\r\n";
        }

        private void btn_Sub_Invoke_Click(object sender, EventArgs e)
        {
            //执行顺序：
            //1、代码A（主线程执行）
            //2、代码D（主线程执行） 和 代码B(子线程执行） 并发执行
            //3、封装消息，并在UI线程中注册消息（子线程执行）
            //4、代码Invoke(主线程执行)
            //5、代码C(子线程执行)

            txt_Message.Text = "";
            txt_Message.Text += "主线程：" + Thread.CurrentThread.ManagedThreadId + "---开始工作\r\n";
            //代码A
            new Thread(() =>
            {
                //代码B
                int temp = 0;
                this.txt_Message.Invoke(del);
                //代码C
                temp = 1;
            }).Start();
            //代码D
            txt_Message.Text += "\r\n主线程：" + Thread.CurrentThread.ManagedThreadId + "---开始结束\r\n";
        }

        private void btn_Sub_BeginInvoke_Click(object sender, EventArgs e)
        {            
            //执行顺序：
            //1、代码A（主线程执行）
            //2、代码D（主线程执行） 和 代码B(子线程执行） 并发执行
            //3、封装消息，并在UI线程中注册消息（子线程执行）
            //4、代码C(子线程执行)
            //5、代码Invoke(主线程执行)

            txt_Message.Text = "";
            txt_Message.Text += "主线程：" + Thread.CurrentThread.ManagedThreadId + "---开始工作\r\n";
            //代码A
            new Thread(() =>
            {
                //代码B
                int temp = 0;
                this.txt_Message.BeginInvoke(del);
                //代码C
                temp = 1;
            }).Start();
            //代码D
            txt_Message.Text += "\r\n主线程：" + Thread.CurrentThread.ManagedThreadId + "---开始结束\r\n";
        }
    }
}
